% BOD Toolbox - version 2.5, 18-April-2012
%
%BOD introduction       >>>http://eeiwzg.et.tu-dresden.de/ae2_files/ae_1_0e.htm<<<
%Loading m-Files        >>>http://eeiwzg.et.tu-dresden.de/ae2_files/ae_1.htm<<<
%
% Z-transform
%   trans       - z-transform including choice of measuring (instantaneous or mean
%                 value) and coupling (sampler or sample&hold), optionally control
%                 vector driven or menu driven, optionally modified z-transform,
%                 optionally LTI system or transfer function syntax;
%
% Controller calculation
%   bod         - Discontinuous Amplitude Optimum (BetragsOptimumDigital=BOD),
%                 optionally menu or control vector driven, current fsolve calling
%                 syntax(PID only), optionally LTI system/transfer function syntax
%   bod_2       - same as bod, but obsolete fsolve calling syntax;
%   bod_gen     - Discontinuous Amplitude Optimum (BetragsOptimumDigital=BOD),
%                 generally use of fsolve and general BOD equation system,
%                 optionally menu or control vector driven, controller selection
%                 via vector orders and switches, first and second order Lead/Lag;
%   eez         - Finite Time Settling (EndlicheEinstellZeit=EEZ); optionally LTI 
%                 system or transfer function syntax, optionally menu driven or 
%                 control vector driven;
%   kmatrix     - calculation of factors of the BOD optimization equation system;
%   bodg        - supporting function - call via bod.m useful only,
%                 please do NOT put in directory private!
%   bod_gen_eq  - supporting function - call via bod_gen.m useful only,
%                 please do NOT put in directory private!
%
%Parameter conversion and running phase shift consideration
%   urlaz       - conversion of controller parameters inside Laplace and z-domain,
%                 optionally menu driven or control vector driven, choice of: 
%                 conversion direction, description in Laplace domain, structure
%                 in z-domain, approximation method;
%   gmt         - determination of general weighted mean dead times (GMT) for bus
%                 data transfer inside single control loops;
%
%Control structure
%   kaskade     - cascade structure optimization with discontinuous controllers
%                 and pre-filters, optionally 2 or 3 control loops, optionally LTI
%                 system or transfer function syntax, control vector driven,
%                 optimization method choice: bod, eez or other adapted syntax;
%   zust_au1    - exemplarily discontinuous state control structure optimization,
%                 automatic calculation of 3 coefficients, application of BOD
%                 -> Discontinuous Amplitude Optimum, reference specified;
%   zust_aug1   - supporting funct. - call via zust_au.m only, z-domain structure; 
%   zust_aup1   - same as zust_au.m but variation of plants time constants: 
%                 motor, spring and load time constant;
%   zust_aut1   - same as zust_au but variation of sampling time and model time
%                 constant of the closed current control loop;
%   zust_...2   - obsolete fsolve calling syntax in contrast to zust_...1;
%
%Analysis and check
%   guete       - calculation of step response quality criteria using SIMULINK
%                 simulation results of a closed loop; optionally choice of:
%                 overshoot and undershoot including point in time; rise time and  
%                 transient time, five different sampling integral criteria;
%   simu        - step response simulation and optionally calculation of quality
%                 criteria of a single control loop;
%
%Subdirectories
%DEMO           - 15 application examples, partly interactive, 'help TB_V25/DEMO'
%SYMDEF	        - add-on: easy symbolic BOD calculations (template with definition
%                 and examples)

%   Copyright (c) 1997-2012 Dr. G.-H. Geitner, TU Dresden. All Rights Reserved.
%   last change: 2012/04/18
